package com.company.bpmdemo.core;

import com.company.bpmdemo.UiNotificationEvent;
import com.company.bpmdemo.entity.Contract;
import com.haulmont.cuba.core.app.events.EntityChangedEvent;
import com.haulmont.cuba.core.global.Events;
import org.springframework.stereotype.Component;
import org.springframework.transaction.event.TransactionPhase;
import org.springframework.transaction.event.TransactionalEventListener;

import javax.inject.Inject;
import java.util.UUID;


@Component(DbUpdate.NAME)
public class DbUpdate  {
    public static final String NAME = "bpmdemo_DbUpdate";
    @Inject
    private Events events;


    @TransactionalEventListener(phase = TransactionPhase.AFTER_COMMIT)

    public void beforeCommit(EntityChangedEvent<Contract, UUID> event) {

        EntityChangedEvent.Type typeEvent = event.getType();

        if (typeEvent == EntityChangedEvent.Type.DELETED) {
            events.publish(new UiNotificationEvent(this));
        }
    }
}